package org.jeecg.modules.okki.wechatinnergroup.job;

import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.jeecg.modules.okki.wechatinnergroup.service.IOkkiShopWechatInnerGroupMsgService;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;

import javax.annotation.Resource;

/**
 * @author Chen
 */
@Slf4j
public class TaskInnerGroupMsgJob implements Job {

    @Resource
    private IOkkiShopWechatInnerGroupMsgService okkiShopWechatInnerGroupMsgService;

    private String parameter;

    public void setParameter(String parameter) {
        this.parameter = parameter;
    }

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        long start = System.currentTimeMillis();
        log.info(String.format("创建【企业微信-内部群消息】任务 - 普通定时任务 TaskInnerGroupMsgJob !  时间:" + DateUtils.now()));

        okkiShopWechatInnerGroupMsgService.getInnerGroupTaskMsg(this.parameter);

        long end = System.currentTimeMillis();
        log.info("已完成创建【企业微信-内部群消息】任务 - 普通定时任务 TaskInnerGroupMsgJob !结束,耗时:{}s", (end - start) / 1000);
    }
}
