package org.jeecg.modules.okki.wechatinnergroup.service;


import lombok.extern.slf4j.Slf4j;
import org.jeecg.modules.okki.wechatinnergroup.dto.GroupMsgResult;
import org.jeecg.modules.okki.wechatinnergroup.entity.OkkiShopWechatInnerGroupMsg;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.data.mongodb.core.aggregation.Aggregation;
import org.springframework.data.mongodb.core.aggregation.AggregationResults;
import org.springframework.data.mongodb.core.query.Criteria;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author 12453
 */
@Slf4j
@Service
public class WechatInnerGroupMongodbRepository{

    @Resource
    private MongoTemplate mongoTemplate;

    /**
     * 保存群聊消息
     * @param shopWechatInnerGroupMsgs
     */
    public void saveAll(List<OkkiShopWechatInnerGroupMsg> shopWechatInnerGroupMsgs){
        shopWechatInnerGroupMsgs.forEach(c->{
            mongoTemplate.save(c);
        });
    }

    /**
     * 查询最大seq
     * @return
     */
    public AggregationResults<GroupMsgResult> findMaxSeqBySiteId(Integer siteId) {
        Aggregation aggregation = Aggregation.newAggregation(
                Aggregation.match(Criteria.where("siteId").is(siteId)),

//                Aggregation.sort(Sort.by(Sort.Order.desc("seq"))),

                Aggregation.group("siteId")
                        .max("seq").as("maxSeq")
                        .max("_id").as("idOfMaxSeq")
                        .first("siteId").as("siteId")
        );
        return mongoTemplate.aggregate(aggregation, "okki_shop_wechat_inner_group_msg", GroupMsgResult.class);
    }

}
